/**
 * \file gui/ptm_island_list_window/ptmislandtablemodel.h
 * \date 30/5/2017
 * \author Olivier Langella
 * \brief display all ptm islands
 */

/*******************************************************************************
* Copyright (c) 2017 Olivier Langella <olivier.langella@u-psud.fr>.
*
* This file is part of XTPcpp.
*
*     XTPcpp is free software: you can redistribute it and/or modify
*     it under the terms of the GNU General Public License as published by
*     the Free Software Foundation, either version 3 of the License, or
*     (at your option) any later version.
*
*     XTPcpp is distributed in the hope that it will be useful,
*     but WITHOUT ANY WARRANTY; without even the implied warranty of
*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*     GNU General Public License for more details.
*
*     You should have received a copy of the GNU General Public License
*     along with XTPcpp.  If not, see <http://www.gnu.org/licenses/>.
*
* Contributors:
*     Olivier Langella <olivier.langella@u-psud.fr> - initial API and implementation
******************************************************************************/

#include "ptmislandtablemodel.h"
#include "ptmislandlistwindow.h"

PtmIslandTableModel::PtmIslandTableModel(PtmIslandListWindow * p_ptm_island_list_window)
{

}

PtmIslandTableModel::~PtmIslandTableModel()
{

}
void PtmIslandTableModel::setIdentificationGroup(IdentificationGroup * p_identification_group) {
    qDebug() << "PtmIslandTableModel::setIdentificationGroup begin ";
    beginResetModel();
    _p_identification_group = p_identification_group;

    //emit headerDataChanged(Qt::Horizontal, 0,11);
    //refresh();
    qDebug() << "PtmIslandTableModel::setIdentificationGroup end ";
    endResetModel();
}
const PtmGroupingExperiment * PtmIslandTableModel::getPtmGroupingExperiment() const {
  if (_p_identification_group == nullptr) {return nullptr;
  }
  return _p_identification_group->getPtmGroupingExperiment();
}
int PtmIslandTableModel::rowCount(const QModelIndex &parent ) const {
    //qDebug() << "ProteinTableModel::rowCount begin ";
    if (getPtmGroupingExperiment() != nullptr) {
        //qDebug() << "ProteinTableModel::rowCount(const QModelIndex &parent ) " << _p_identification_group->getProteinMatchList().size();
        return (int) getPtmGroupingExperiment()->getPtmIslandList().size();
    }
    return 0;
}
int PtmIslandTableModel::columnCount(const QModelIndex &parent ) const {
    //qDebug() << "ProteinTableModel::columnCount begin ";
    if (getPtmGroupingExperiment() != nullptr) {
        return 3;
    }
    return 0;
}
QVariant PtmIslandTableModel::headerData(int section, Qt::Orientation orientation, int role) const
{
    if (getPtmGroupingExperiment() == nullptr) return QVariant();
    if (orientation == Qt::Horizontal)
    {
    }
    return QVariant();
}
QVariant PtmIslandTableModel::data(const QModelIndex &index, int role ) const {
    // generate a log message when this method gets called
    if (getPtmGroupingExperiment() == nullptr) return QVariant();
    int row = index.row();
    int col = index.column();
     switch(role) {
        case Qt::DisplayRole:
        if (_p_identification_group == nullptr) {
            return QVariant();
        }
        switch (col) {
	  case 0:
            return QVariant(getPtmGroupingExperiment()->getPtmIslandList().at(row).get()->getGroupingId());
	break;
	  case 1:
            return QVariant(getPtmGroupingExperiment()->getPtmIslandList().at(row).get()->getProteinMatch()->getProteinXtpSp().get()->getAccession());
	break;
	}
    }
    return QVariant();
}


void PtmIslandTableModel::onPtmIslandDataChanged() {
    qDebug() << "PtmIslandTableModel::onPtmIslandDataChanged begin " << rowCount();
    emit layoutAboutToBeChanged();
    emit layoutChanged();
}